package com.fetchingStratergy.service.impl;

import com.fetchingStratergy.domain.Department;
import com.fetchingStratergy.domain.Dependent;
import com.fetchingStratergy.domain.Employee;
import com.fetchingStratergy.repository.EmployeeRepository;
import com.fetchingStratergy.service.DepartmentService;
import com.fetchingStratergy.service.EmployeeService;

public class EmployeeServiceImpl implements EmployeeService {
	private EmployeeRepository employeeRepository;
	
	private DepartmentService departmentService;
	
	public EmployeeServiceImpl(EmployeeRepository employeeRepository,
							   DepartmentService departmentService) {
		super();
		this.employeeRepository = employeeRepository;
		this.departmentService = departmentService;
	}

	public void createEmployee(String employeeName) {
		Employee employee = new Employee(employeeName);
		employeeRepository.createEmployee(employee);
	}

	public void deleteEmployee(int employeeId) {
		employeeRepository.deleteEmployee(findEmployeeById(employeeId));
	}

	public Employee findEmployeeById(int employeeId) {
		 Employee employee = employeeRepository.findEmployeeById(employeeId);
		 return employee;
	}

	public void createEmployee(String employeeName, int departmentId) {
		Department department = departmentService.findDepartmentById(departmentId);
		Employee employee = new Employee(employeeName, department);
		employeeRepository.createEmployee(employee);
		
	}

	public void addDependent(int employeeId, String dependentName) {
		employeeRepository.findEmployeeById(employeeId).addDependent(new Dependent(dependentName));
	}

}
